//Demo sketch for Piano_Tutor project: TUTOR VER runs 4 servos

#include <stdio.h> 
#include <string.h> 
#include <VarSpeedServo.h> 
#define INPUT_SIZE 50 //Max inData size

//pin setup 
int pin0 = 8; //"SET ME!"
int pin1 = 10; //"SET ME!"
int pin2 = 12; //"SET ME!"

int position0 = 0; //initializing data
int velocity0 = 0;
int position1 = 60;
int velocity1 = 0;
int position2 = 60;
int velocity2 = 0;

VarSpeedServo servo0; //create servo objects
VarSpeedServo servo1;
VarSpeedServo servo2;

void test_slowmove(){
  servo0.slowmove(45, 75); //servo0 moves slowly to 45
  delay(500);
  servo0.slowmove(0, 150); //servo0 moves faster to 0
  delay(500);
  servo1.slowmove(45, 75); //servo1 moves slowly to 45
  delay(500);
  servo1.slowmove(0, 150); //servo1 moves faster to 0
  delay(500);
}

void setup() {

    //servo setup
    int servoMin = -90; //"SET ME!"
    int servoMax = 130; //"SET ME!"
    servo0.attach (pin0, servoMin, servoMax);
    servo1.attach (pin1, servoMin, servoMax);
    servo2.attach (pin2, servoMin, servoMax);

    //serial setup
    Serial.begin(9600); // set the baud rate

    //TEST SLOWMOVE
    //test_slowmove(); //Comment out after testing
}

void loop() {
  ////////////////////////// print data to serial /////////////////////////
  static unsigned long last_update_clock = 0;
  unsigned long now = micros();
  unsigned long interval = now - last_update_clock;
  last_update_clock = now;

  static long status_timer;
  status_timer -= interval;
  if (status_timer <= 0) {
     status_timer += 10;

     //prints "position0 position1 position2 position3\n" DO NOT NEED TO SEND SPEED TO PYTHON
     //Serial.print("SENDING TO SERIAL");
     Serial.print(servo0.read()); Serial.print(" ");
     Serial.print(servo1.read()); Serial.print(" ");
     Serial.println(servo2.read());
   }
  
  if (Serial.available() > 0){ //if recieving data from Serial
    /*
    ///////////////////////// Parse inData ////////////////////////////////
    //Code edited from https://arduino.stackexchange.com/questions/1013/how-do-i-split-an-incoming-string
    // Get next command from Serial (add 1 for final 0)
    char input[INPUT_SIZE + 1];
    byte size = Serial.readBytes(input, INPUT_SIZE);

    if (size > 0){
    
    // Add the final 0 to end the C string
    input[size] = 0;

    // Read line
    char* token = strtok(input, " ");
    position0 = atoi(token);
    token = strtok(NULL, " ");
    velocity0 = atoi(token);
    token = strtok(NULL, " ");
    position1 = atoi(token);
    token = strtok(NULL, " ");
    velocity1 = atoi(token);*/

    position0 = Serial.parseInt();
    velocity0 = Serial.parseInt();
    position1 = Serial.parseInt();
    velocity1 = Serial.parseInt();
    position2 = Serial.parseInt();
    velocity2 = Serial.parseInt();


    ////////////////////////// Execute move /////////////////////////////////
    servo0.slowmove(position0, velocity0);
    servo1.slowmove(position1, velocity1);
    servo2.slowmove(position2, velocity2);
    }
}
